__gnu_debug::_Safe_node_sequence< _Sequence >(3cxx)

NAME
__gnu_debug::_Safe_node_sequence< _Sequence > - Like _Safe_sequence but with a special _M_invalidate_all implementation not invalidating past-the-end iterators. Used by node based sequence.

SYNOPSIS

Inherits __gnu_debug::_Safe_sequence< _Sequence >.

Inherited by __gnu_debug::_Safe_container< multiset< _Key, std::less< _Key >, std::allocator< _Key > >, std::allocator< _Key >, __gnu_debug::_Safe_node_sequence >, __gnu_debug::_Safe_container< multimap< _Key, _Tp, std::less< _Key >, std::allocator< std::pair< const _Key, _Tp > > >, std::allocator< std::pair< const _Key, _Tp > >, __gnu_debug::_Safe_node_sequence >, __gnu_debug::_Safe_container< list< _Tp, std::allocator< _Tp > >, std::allocator< _Tp >, __gnu_debug::_Safe_node_sequence >, __gnu_debug::_Safe_container< map< _Key, _Tp, std::less< _Key >, std::allocator< std::pair< const _Key, _Tp > > >, std::allocator< std::pair< const _Key, _Tp > >, __gnu_debug::_Safe_node_sequence >, and __gnu_debug::_Safe_container< set< _Key, std::less< _Key >, std::allocator< _Key > >, std::allocator< _Key >, __gnu_debug::_Safe_node_sequence >.

  Public Member Functions

template<typename _Predicate > void _M_invalidate_if (_Predicate __pred)
template<typename _Predicate > void _M_transfer_from_if (_Safe_sequence &__from, _Predicate __pred)

  Public Attributes

_Safe_iterator_base * _M_const_iterators
The list of constant iterators that reference this container.
_Safe_iterator_base * _M_iterators
The list of mutable iterators that reference this container.
unsigned int _M_version
The container version number. This number may never be 0.

  Protected Member Functions

void _M_detach_all ()
void _M_detach_singular ()
__gnu_cxx::__mutex & _M_get_mutex () throw ()
void _M_invalidate_all ()
void _M_invalidate_all () const
void _M_revalidate_singular ()
void _M_swap (_Safe_sequence_base &__x) noexcept

Detailed Description

  template<typename _Sequence>
class __gnu_debug::_Safe_node_sequence< _Sequence >" Like _Safe_sequence but with a special _M_invalidate_all implementation not invalidating past-the-end iterators. Used by node based sequence.

Definition at line 131 of file safe_sequence.h.

Member Function Documentation

  void __gnu_debug::_Safe_sequence_base::_M_detach_all () [protected], [inherited]
Detach all iterators, leaving them singular.

Referenced by __gnu_debug::_Safe_sequence_base::~_Safe_sequence_base().

  void __gnu_debug::_Safe_sequence_base::_M_detach_singular () [protected], [inherited]
Detach all singular iterators.

Postcondition
    for all iterators i attached to this sequence, i->_M_version == _M_version.

  __gnu_cxx::__mutex& __gnu_debug::_Safe_sequence_base::_M_get_mutex () [protected], [inherited]
For use in _Safe_sequence.

Referenced by __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_from_if().

  void __gnu_debug::_Safe_sequence_base::_M_invalidate_all () const [inline], [protected], [inherited]
Invalidates all iterators.

Definition at line 256 of file safe_base.h.

References __gnu_debug::_Safe_sequence_base::_M_version.

  template<typename _Sequence > template<typename _Predicate > void __gnu_debug::_Safe_sequence< _Sequence >::_M_invalidate_if (_Predicate __pred) [inherited]
Invalidates all iterators x that reference this sequence, are not singular, and for which __pred(x) returns true. __pred will be invoked with the normal iterators nested in the safe ones.

Definition at line 37 of file safe_sequence.tcc.

  void __gnu_debug::_Safe_sequence_base::_M_revalidate_singular () [protected], [inherited]
Revalidates all attached singular iterators. This method may be used to validate iterators that were invalidated before (but for some reason, such as an exception, need to become valid again).

  void __gnu_debug::_Safe_sequence_base::_M_swap (_Safe_sequence_base & __x) [protected], [noexcept], [inherited]
Swap this sequence with the given sequence. This operation also swaps ownership of the iterators, so that when the operation is complete all iterators that originally referenced one container now reference the other container.

  template<typename _Sequence > template<typename _Predicate > void __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_from_if (_Safe_sequence< _Sequence > & __from, _Predicate __pred) [inherited]
Transfers all iterators x that reference from sequence, are not singular, and for which __pred(x) returns true. __pred will be invoked with the normal iterators nested in the safe ones.

Definition at line 68 of file safe_sequence.tcc.

References std::__addressof(), __gnu_debug::_Safe_sequence_base::_M_const_iterators, __gnu_debug::_Safe_iterator_base::_M_detach_single(), __gnu_debug::_Safe_sequence_base::_M_get_mutex(), __gnu_debug::_Safe_sequence_base::_M_iterators, __gnu_debug::_Safe_iterator_base::_M_next, __gnu_debug::_Safe_iterator_base::_M_prior, __gnu_debug::_Safe_iterator_base::_M_sequence, and __gnu_debug::_Safe_iterator_base::_M_version.

Member Data Documentation

  _Safe_iterator_base* __gnu_debug::_Safe_sequence_base::_M_const_iterators [inherited]

The list of constant iterators that reference this container.

Definition at line 197 of file safe_base.h.

Referenced by __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_from_if().

  _Safe_iterator_base* __gnu_debug::_Safe_sequence_base::_M_iterators [inherited]

The list of mutable iterators that reference this container.

Definition at line 194 of file safe_base.h.

Referenced by __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_from_if().

  unsigned int __gnu_debug::_Safe_sequence_base::_M_version [mutable], [inherited]

The container version number. This number may never be 0.

Definition at line 200 of file safe_base.h.

Referenced by __gnu_debug::_Safe_sequence_base::_M_invalidate_all().

Author

Generated automatically by Doxygen for libstdc++ from the source code.